//+------------------------------------------------------------------+
//| QQE 4hr_15min TESTING                                            |
//| triggers on 4 hour QQE, then uses 15 min QQE to enter trade.     |
//+------------------------------------------------------------------+

#property copyright "Expert Advisor Builder"
#property link      "http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/"
#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4
extern int MagicNumber = 0;
extern bool SignalMail = False;
extern bool EachTickMode = False;
extern double Lots = 1.0;
extern int Slippage = 3;
extern bool UseStopLoss = True;
extern int StopLoss = 300;
extern bool UseTakeProfit = False;
extern int TakeProfit = 1000;
extern bool UseTrailingStop = True;
extern int TrailingStop = 300;
extern int Nbr_Period = 10;
extern double Multiplier = 3.0;
int SF          = 25 ;
int RSI_Period  = 18  ;
int DART_Factor = 2  ;
int upper       = 65 ;
int lower       = 35 ;
int SF_15          = 11 ;
int RSI_Period_15  = 6  ;
int DART_Factor_15 = 2  ;
int upper_15       = 65 ;
int lower_15       = 35 ;
int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()  {
             BarCount = Bars;
             if(EachTickMode) 
                Current = 0; 
             else 
                Current = 1;
             return(0);
            } // init...
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){
             return(0);
            } // deinit...
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
             int Order = SIGNAL_NONE;
             int Total, Ticket;
             double StopLossLevel, TakeProfitLevel;
             if(EachTickMode && Bars != BarCount) 
                TickCheck = False;
             Total = OrdersTotal();
             Order = SIGNAL_NONE;
//+------------------------------------------------------------------+
//| Variable Begin                                                   |
//+------------------------------------------------------------------+
             int QQE_4hr    = iCustom( 0, 240, "c_QQEA",  SF,  RSI_Period, DART_Factor,  0, 1 );
             int QQE_4hr_2  = iCustom( 0, 240, "c_QQEA",  SF,  RSI_Period, DART_Factor,  0, 2 );                              
             int QQE_15m    = iCustom( 0, 15, "c_QQEA",  SF_15,  RSI_Period_15, DART_Factor_15,  0, 1 );
             int QQE_15m_2  = iCustom( 0, 15, "c_QQEA",  SF_15,  RSI_Period_15, DART_Factor_15,  0, 2 );
//+------------------------------------------------------------------+
//| Variable End                                                     |
//+------------------------------------------------------------------+
//Check position                 
             bool IsTrade = False;
             for(int i = 0; i < Total; i ++) 
               {                       
                OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
                if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) 
                  {                 
                   IsTrade = True;
                   if(OrderType() == OP_BUY) 
                     {            
//Close                          
//+------------------------------------------------------------------+
//| Signal Begin (Exit Buy)                                           |
//+------------------------------------------------------------------+
                      if((QQE_4hr_2 > upper) 
                          && (QQE_15m_2 > upper_15)) 
                         Order = SIGNAL_CLOSEBUY;
//+------------------------------------------------------------------+
//| Signal End (Exit Buy)                                             |
//+------------------------------------------------------------------+
                      if(Order == SIGNAL_CLOSEBUY 
                          && ((EachTickMode && !TickCheck) 
                          || (!EachTickMode && (Bars != BarCount)))) 
                        {
                         OrderClose(OrderTicket(), 
                                    OrderLots(), 
                                    Bid, 
                                    Slippage, 
                                    MediumSeaGreen);
                         if(SignalMail) 
                             SendMail("[Signal Alert]", 
                                      "[" 
                                      + Symbol() 
                                      + "] " 
                                      + DoubleToStr(Bid, Digits)  
                                      + " Close Buy");
                         if(!EachTickMode) 
                             BarCount = Bars;
                         IsTrade = False;
                         continue;
                        }  // if(Order...
//Trailing stop        
                      if(UseTrailingStop  
                          && TrailingStop > 0) 
                        {                 
                         if(Bid - OrderOpenPrice() > Point * TrailingStop) 
                           {
                            if(OrderStopLoss() < Bid - Point * TrailingStop) 
                              {
                               OrderModify(OrderTicket(), 
                                           OrderOpenPrice(), 
                                           Bid - Point * TrailingStop, 
                                           OrderTakeProfit(), 
                                           0, 
                                           MediumSeaGreen);
                               if(!EachTickMode) 
                                  BarCount = Bars;
                               continue;
                              } // if(Order...
                           }  // if(Bid...
                        }  // if(Use...
                     } // if(Order...
                   else 
                     {  
//Close                  
//+------------------------------------------------------------------+
//| Signal Begin (Exit Sell)                                          |
//+------------------------------------------------------------------+
                      if((QQE_4hr_2 < lower) 
                          && (QQE_15m_2 < lower_15)) 
                         Order = SIGNAL_CLOSESELL;
//+------------------------------------------------------------------+
//| Signal End (Exit Sell)                                       
//+------------------------------------------------------------------+
                      if(Order == SIGNAL_CLOSESELL 
                          && ((EachTickMode && !TickCheck) 
                          || (!EachTickMode && (Bars != BarCount)))) 
                        {
                         OrderClose(OrderTicket(), 
                                    OrderLots(), 
                                    Ask, 
                                    Slippage, 
                                    DarkOrange);
                         if(SignalMail) 
                            SendMail("[Signal Alert]", 
                                     "["  
                                     + Symbol() 
                                     + "] " 
                                     + DoubleToStr(Ask, Digits) 
                                     + " Close Sell");
                         if(!EachTickMode) 
                            BarCount = Bars;
                         IsTrade = False;
                         continue;
                        } // if(Order...
//Trailing stop            
                      if(UseTrailingStop && TrailingStop > 0) 
                        {                 
                         if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) 
                           {
                            if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) 
                              {
                               OrderModify(OrderTicket(),  
                                           OrderOpenPrice(),  
                                           Ask + Point * TrailingStop, 
                                           OrderTakeProfit(), 
                                           0, 
                                           DarkOrange);
                               if(!EachTickMode) 
                                  BarCount = Bars;
                               continue;
                              } // if((Order.
                           }  // if((Order...
                        }  // if(Use...                    
                     }  // else...
                  }  // if(Order...
               }  // for... 
                               
//+------------------------------------------------------------------+
//| Signal Begin (Entry)                                              |
//+------------------------------------------------------------------+
             if((QQE_4hr > lower) 
                 && (QQE_4hr > QQE_4hr_2) 
                 && (QQE_15m > QQE_15m_2))
                Order = SIGNAL_BUY;
             if((QQE_4hr < upper) 
                 && (QQE_4hr < QQE_4hr_2) 
                 && (QQE_15m < QQE_15m_2))    
                Order = SIGNAL_SELL;     
//+------------------------------------------------------------------+
//| Signal End                                                       |
//+------------------------------------------------------------------+
//Buy                          
             if(Order == SIGNAL_BUY 
                 && ((EachTickMode 
                 && !TickCheck) || (!EachTickMode && (Bars != BarCount))))
               {         
                if(!IsTrade) 
                  {         
//Check free margin    
                   if(AccountFreeMargin() < (1000 * Lots)) 
                     {
                      Print("We have no money. Free Margin = ", AccountFreeMargin());
                      return(0);
                     } // if(Account...
                   if(UseStopLoss) 
                     {
                      StopLossLevel = Ask - StopLoss * Point;  
                     } // if(Use...
                   else 
                      StopLossLevel = 0.0;
                   if(UseTakeProfit) 
                      TakeProfitLevel = Ask 
                      + TakeProfit * Point;  
                   else  
                      TakeProfitLevel = 0.0;
                   Ticket = OrderSend(Symbol(), 
                                      OP_BUY, 
                                      Lots, 
                                      Ask, 
                                      Slippage, 
                                      StopLossLevel, 
                                      TakeProfitLevel, 
                                      "Buy(#" + MagicNumber + ")", 
                                      MagicNumber, 
                                      0, 
                                      DodgerBlue);
                   if(Ticket > 0) 
                     {
                      if(OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                        {
                         Print("BUY order opened : ", 
                               OrderOpenPrice());
                         if(SignalMail) 
                            SendMail("[Signal Alert]", 
                                     "[" 
                                     + Symbol() 
                                     + "] " 
                                     + DoubleToStr(Ask, Digits) 
                                     + " Open Buy");
                        } // if(Order...
                      else 
                        {
                         Print("Error opening BUY order : ", 
				                   GetLastError());
	                     } // else
                     } // if(Ticket... 
                   if(EachTickMode) 
                      TickCheck = False;
                   if(!EachTickMode) 
                      BarCount = Bars;
                   return(0);
                  } // if(!Is...
               } // if(Order...
//Sell                     
             if(Order == SIGNAL_SELL 
                 && ((EachTickMode 
                 && !TickCheck) || (!EachTickMode 
                 && (Bars != BarCount)))) 
               {         
                if(!IsTrade) 
                  {           
//Check free margin                            
                   if(AccountFreeMargin() < (1000 * Lots)) 
                     {
                      Print("We have no money. Free Margin = ",  
                            AccountFreeMargin());
                      return(0);
                     } // if(Account...         
                   if(UseStopLoss) 
                      StopLossLevel = Bid + StopLoss * Point; 
                   else 
                      StopLossLevel = 0.0;    
                   if(UseTakeProfit) 
                      TakeProfitLevel = Bid - TakeProfit * Point; 
                   else 
                      TakeProfitLevel = 0.0;
                   Ticket = OrderSend(Symbol(), 
                                      OP_SELL, 
                                      Lots, 
                                      Bid, 
                                      Slippage, 
                                      StopLossLevel, 
                                      TakeProfitLevel, 
                                      "Sell(#" + MagicNumber + ")", 
                                      MagicNumber, 
                                      0, 
                                      DeepPink);
                   if(Ticket > 0) 
                     {
                      if(OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                        {
				             Print("SELL order opened : ", 
				                   OrderOpenPrice());
                         if(SignalMail) 
                            SendMail("[Signal Alert]", 
                                     "[" 
                                     + Symbol() 
                                     + "] " 
                                     + DoubleToStr(Bid, Digits) 
                                     + " Open Sell");
		                  } // if(Order...
			             else 
			               {
				             Print("Error opening SELL order : ", 
				                   GetLastError());
			               } // else 
		               } // if(Ticket...            
                   if(EachTickMode) 
                      TickCheck = False;
                   if(!EachTickMode)  
                      BarCount = Bars;
                   return(0);
                  } // if(!Is...
               } //if(Order...                    
             if(!EachTickMode) 
                BarCount = Bars;
             return(0);
            } // start...
//+------------------------------------------------------------------+